freeze;

/////////////////////////////////////////////////////////////////////////
// mms.m
/////////////////////////////////////////////////////////////////////////
// $Revision: 36862 $
// $Date: 2012-01-09 07:07:31 +1100 (Mon, 09 Jan 2012) $
// $LastChangedBy: kasprzyk $
/////////////////////////////////////////////////////////////////////////
// Author: Alexander Kasprzyk
/////////////////////////////////////////////////////////////////////////
// Allows logging via the Magma Messaging System.
/////////////////////////////////////////////////////////////////////////

import "logger.m": set_logger, set_logger_store_value, get_logger_store_value;

/////////////////////////////////////////////////////////////////////////
// Local functions
/////////////////////////////////////////////////////////////////////////

// Sends the given message to the MMS.
procedure mms_logger_handler(message,level)
    bool,send:=IsIntrinsic("MMSSend");
    if bool then
        bool,recipient:=get_logger_store_value("mms_recipient");
        assert bool;
        send(recipient,message);
    end if;
end procedure;

/////////////////////////////////////////////////////////////////////////
// Intrinsics
/////////////////////////////////////////////////////////////////////////

intrinsic SetLoggerToMMS( recipient::MonStgElt )
{Sets log messages to be sent to the MMS server, and enables logging.}
    // Sanity checks
    recipient:=Trim(recipient);
    require #recipient ne 0: "The recipient name must not be empty";
    bool,registered:=IsIntrinsic("MMSIsRegistered");
    require bool: "MMS support is not enabled";
    require registered(): "You are not registered with the MMS server (use MMSRegister).";
    // Set the logger
    set_logger_store_value("mms_recipient",recipient);
    set_logger(mms_logger_handler,"%d: %s");
end intrinsic;
